package com.wall.turing.wallpapers.accctivities

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.view.inputmethod.EditorInfo
import android.view.inputmethod.InputMethodManager
import android.widget.TextView.OnEditorActionListener
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.GridLayoutManager
import com.wall.turing.wallpapers.R
import com.wall.turing.wallpapers.databinding.TuringSearchBinding
import com.wall.turing.wallpapers.uutils.AppUtils
import com.wall.turing.wallpapers.uutils.DatabaseManager
import com.wall.turing.wallpapers.uutils.AdapterHelper
import com.wall.turing.wallpapers.connect.TuringItemClick
import com.wall.turing.wallpapers.myselfbean.Wallpaper
import com.wall.turing.wallpapers.adapteres.ListAdapter

class TuringSearchActivity : AppCompatActivity() ,
    TuringItemClick {
    private lateinit var adapterWallapper: ListAdapter
    private lateinit var binding:TuringSearchBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = TuringSearchBinding.inflate(layoutInflater)
        setContentView(binding.root)
        AppUtils.initFull(this, false)
        initList()
        binding.imageviewBack.setOnClickListener {
            finish()
        }
    }


    private fun initList() {
        val height = AppUtils.dp2Px(180)
        adapterWallapper =
            ListAdapter(this, height, true)
        adapterWallapper.setInfoWallpaperListener(this)
        val recyclerAdapterHelper = AdapterHelper(10, 10, 15)
        val gridLayoutManager = GridLayoutManager(this, 2)
        binding.resultRecycler.run {
            layoutManager = gridLayoutManager
            addItemDecoration(recyclerAdapterHelper)
            adapter = adapterWallapper
        }

        binding.et.setOnEditorActionListener(OnEditorActionListener { v, actionId, event ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH) {
                startSearch()
                return@OnEditorActionListener true
            }
            false
        })
        binding.btnSearch.setOnClickListener { startSearch() }
    }

    private fun closeKeyboard() {
        val imm =  getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
        imm.hideSoftInputFromWindow(binding.et.windowToken, 0)
    }

    private fun startSearch() {
        closeKeyboard()
        binding.searchPb.visibility = View.VISIBLE
        val string: String = binding.et.text.toString()
        if (string.isNotEmpty()) {
            val search = DatabaseManager.search(string)
            if (search.size > 0) {
                showEmpty(false)
                adapterWallapper.setDataInfo(search)
                binding.searchPb.visibility = View.GONE
            } else {
                binding.searchPb.visibility = View.GONE
                showEmpty(true)
            }

        } else {
            binding.searchPb.visibility = View.GONE
            Toast.makeText(
                this,
                getString(R.string.please_input_keyword),
                Toast.LENGTH_SHORT
            ).show()
        }
    }

    private fun showEmpty(showEmpty: Boolean) {
        if (showEmpty) {
            binding.emptyLayout.visibility = View.VISIBLE
            binding.resultRecycler.visibility = View.GONE
        } else {
            binding.emptyLayout.visibility = View.GONE
            binding.resultRecycler.visibility = View.VISIBLE
        }
    }

    override fun onItemClickAction(info: Wallpaper?) {
        val intent = Intent(this, TuringWallpaperActivity::class.java)
        intent.putExtra(AppUtils.key_info, info)
        startActivity(intent)
    }
}